/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

Components.utils.import("resource://gre/modules/Services.jsm");

var gCheckInterval = 12000;
var gOpenTime = 6000;
var gSliderTimeout;

function checkSliderNeed() {
    let calAlarmWindow = Services.wm.getMostRecentWindow("Calendar:AlarmWindow");
    let alarmRichlist = calAlarmWindow.document.getElementById("alarm-richlist");
    if (calAlarmWindow && alarmRichlist.hasChildNodes) {
        setupSlider();
    }
}

function setSliderTimeout() {
    try {
        gCheckInterval = Services.prefs.getIntPref("calAlarmSlider.checkInterval");
        gOpenTime = Services.prefs.getIntPref("calAlarmSlider.totalOpenTime");
    }
    catch (ex) {
    }
    gSliderTimeout = setInterval(checkSliderNeed, gCheckInterval + gOpenTime);
    Services.prefs.setBoolPref("calAlarmSlider.timeoutSet", true);
}

function clearSliderTimeout() {
    if (gSliderTimeout) {
        window.clearInterval(gSliderTimeout);
    }
}

function setupSlider() {
    this.openSlider = Services.ww.openWindow(
        null,
        "chrome://calalarmslider/content/calendar-alarm-slider.xul",
        "calAlarmSlider",
        "chrome,dialog=yes,titlebar=no,popup=yes",
        null);
}

function initSlider() {
    setTimeout(setupSlider, 500);
    let showPermanentSlider = Services.prefs.getBoolPref("calAlarmSlider.showPermanentSlider");
    if (showPermanentSlider == false) {
        setSliderTimeout();
    }
}

function removeSlider() {
    let calAlarmSliderWindow = Services.wm.getMostRecentWindow("Calendar:AlarmSliderWindow");
    let diehardSlider = Services.prefs.getBoolPref("calAlarmSlider.diehardSlider");
    if (!diehardSlider) {
        clearSliderTimeout();
        if (calAlarmSliderWindow) {
            calAlarmSliderWindow.closeAlert();
        }
    }
}
