/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

Components.utils.import("resource://gre/modules/Services.jsm");

function onPrefPaneLoad() {
    let sliderType = document.getElementById("calAlarmSliderType");
    let showPermanentSlider = Services.prefs.getBoolPref("calAlarmSlider.showPermanentSlider");
    if (showPermanentSlider == true) {
        disableIntervalUI();
        sliderType.selectedIndex = 0;
    } else {
        enableIntervalUI();
        sliderType.selectedIndex = 1;
    }
    sizeToContent();
    var vbox = document.getElementById("cal-pref-wrapper");
    vbox.height = vbox.boxObject.height;
    sizeToContent();
}

function setPermanentSlider() {
    disableIntervalUI();
    Services.prefs.setBoolPref("calAlarmSlider.showPermanentSlider",true);
}

function setNonpermanentSlider() {
    enableIntervalUI();
    Services.prefs.setBoolPref("calAlarmSlider.showPermanentSlider",true);
}

function disableIntervalUI() {
    var intervalOptions = document.getElementById("intervalOptions");
    var hideableItems = new Array();
    hideableItems = intervalOptions.getElementsByAttribute("hideable", true);
    for (var i = 0; i < hideableItems.length; ++i) {
        var item = hideableItems[i];
        if (!item.hasAttribute("disabled", true)) {
            item.setAttribute("disabled", true);
        }
    }
}

function enableIntervalUI() {
    var intervalOptions = document.getElementById("intervalOptions");
    var hideableItems = new Array();
    hideableItems = intervalOptions.getElementsByAttribute("hideable", true);
    for (var i = 0; i < hideableItems.length; ++i) {
        var item = hideableItems[i];
        if (item.hasAttribute("disabled", true)) {
  	        item.removeAttribute("disabled");
        }
    }
}

function onUnload(prefwindow) {
    var radio1 = document.getElementById("permanentSliderRadio");
    var radio2 = document.getElementById("intervalSliderRadio");
    if (radio1.selected) {
        Services.prefs.setBoolPref("calAlarmSlider.showPermanentSlider",true);
    }
    if (radio2.selected) {
        var totalOpenTime = document.getElementById("calAlarmSlider.totalOpenTime.textbox").value;
        var checkInterval = document.getElementById("calAlarmSlider.checkInterval.textbox").value;
        Services.prefs.setBoolPref("calAlarmSlider.showPermanentSlider",false);
        Services.prefs.setIntPref("calAlarmSlider.totalOpenTime",totalOpenTime);
        Services.prefs.setIntPref("calAlarmSlider.checkInterval",checkInterval);
    }
}
